//+------------------------------------------------------------------+ 
//| prusax.mq4 
//| 
//+------------------------------------------------------------------+ 

#property indicator_separate_window 
#property indicator_buffers 2 
#property indicator_color1 White 
#property indicator_color2 Red 
#property indicator_width1 3
#property indicator_width2 3

extern int FromTxt=-1;  //      . 
                        // -1 -       
                        // M1- 2, M5 - 6, M15 - 10, M30 - 12, H1 - 15, H4 - 30, D1 - 80, W1 - 3000, MN1 - 600
                        //      . 
//---- buffers 
double BufferUP[];
double BufferDN[];
string ShortName="prusax_txt_v1";
int WinNum;
//+------------------------------------------------------------------+ 
//| Custom indicator initialization function | 
//+------------------------------------------------------------------+ 
int init(){ 
   IndicatorBuffers(2); 
   SetIndexStyle(0,DRAW_HISTOGRAM); 
   SetIndexBuffer(0,BufferUP); 
   SetIndexStyle(1,DRAW_HISTOGRAM); 
   SetIndexBuffer(1,BufferDN);
   SetIndexDrawBegin(0,10); 
   SetIndexDrawBegin(1,10); 
   
   if(FromTxt==-1)FromTxt=PTA(Period());

return(0); 
} 
//+------------------------------------------------------------------+ 
//| 
//+------------------------------------------------------------------+ 
int start(){


   ShortName="prusax_txt_v1";
   IndicatorShortName(ShortName);
   WinNum=WindowFind(ShortName);  
   int i,counted_bars=IndicatorCounted(); 
      for(i=Bars-counted_bars-1;i>=0;i--){
         BufferUP[i]=((High[i]-Open[i])+(Close[i]-Low[i]));
         BufferDN[i]=-((Open[i]-Low[i])+(High[i]-Close[i]));
         
         double sum=MathAbs(BufferUP[i])+MathAbs(BufferDN[i]);
            if(sum!=0){
               int UpPs=MathRound(100.0*BufferUP[i]/sum);
               int DnPs=100-UpPs;
       
               fObjText("Prusax_UP_"+Time[i],Time[i],BufferUP[i]+Point*FromTxt,UpPs,White,7,WinNum,"Arial Narrow");
               fObjText("Prusax_DN_"+Time[i],Time[i],BufferDN[i],DnPs,Red,7,WinNum,"Arial Narrow");
               
            }
      }


return(0); 
} 
//+------------------------------------------------------------------+ 

void fObjText(
   string aObjectName,     // 1 
   datetime aTime_1,       // 2 
   double aPrice_1,        // 3 
   string aText,           // 4 
   color aColor=Red,       // 5 
   int aFontSize=8,        // 6  
   int aWindowNumber=0,    // 7 
   string aFont="Arial",   // 8 
   bool aBack=false        // 9 
   
   ){
   
   // fText("",Time[1],Close[1],"",Red,8);
   // fText("",Time[1],Close[1],"",Red,8,0,"Arial",false);
   
      if(ObjectFind(aObjectName)!=aWindowNumber){
         ObjectCreate(aObjectName,OBJ_TEXT,aWindowNumber,aTime_1,aPrice_1);
      }      
   ObjectSet(aObjectName,OBJPROP_TIME1,aTime_1);
   ObjectSet(aObjectName,OBJPROP_PRICE1,aPrice_1);   
   ObjectSetText(aObjectName,aText,aFontSize,aFont,aColor);
   ObjectSet(aObjectName,OBJPROP_BACK,aBack);
}

int deinit(){
   fObjDeleteByPrefix("Prusax_UP_");
   fObjDeleteByPrefix("Prusax_DN_");   

}

void fObjDeleteByPrefix(string aPrefix){
   for(int i=ObjectsTotal()-1;i>=0;i--){
      if(StringFind(ObjectName(i),aPrefix,0)==0){
         ObjectDelete(ObjectName(i));
      }
   }
}

int PTA(int aPeriod){
   switch(aPeriod){
      case PERIOD_M1:
         return(2);
      case PERIOD_M5:
         return(6);
      case PERIOD_M15:
         return(10);
      case PERIOD_M30:
         return(12);             
      case PERIOD_H1:
         return(15);  
      case PERIOD_H4:
         return(30);  
      case PERIOD_D1:
         return(80);                   
      case PERIOD_W1:
         return(3000); 
      case PERIOD_MN1:
         return(600);          
   }
}

